Index: ReactOS.rbuild
===================================================================
--- ReactOS.rbuild	(revision 21808)
+++ ReactOS.rbuild	(working copy)
@@ -24,14 +24,12 @@
     <define name="KDBG" value="1" />
     <property name="DBG_OR_KDBG" value="true" />
   </if>
-  
-  <if property="GDB" value="0">
-    <compilerflag>-Os</compilerflag>
-    <compilerflag>-Wno-strict-aliasing</compilerflag>
-    <compilerflag>-ftracer</compilerflag>
-    <compilerflag>-momit-leaf-frame-pointer</compilerflag>
-    <compilerflag>-mpreferred-stack-boundary=2</compilerflag>
-  </if>
+  <compilerflag>-O3</compilerflag>
+  <compilerflag>-fno-optimize-sibling-calls</compilerflag>
+  <compilerflag>-Wno-strict-aliasing</compilerflag>
+  <compilerflag>-ftracer</compilerflag>
+  <compilerflag>-momit-leaf-frame-pointer</compilerflag>
+  <compilerflag>-mpreferred-stack-boundary=2</compilerflag>
   <compilerflag>-Wpointer-arith</compilerflag>
 
   <include>.</include>
Index: subsystems/win32/win32k/ntuser/winsta.c
===================================================================
--- subsystems/win32/win32k/ntuser/winsta.c	(revision 21808)
+++ subsystems/win32/win32k/ntuser/winsta.c	(working copy)
@@ -97,10 +97,10 @@
 NTSTATUS
 STDCALL
 IntWinStaObjectOpen(OB_OPEN_REASON Reason,
+                    PEPROCESS Process,
                     PVOID ObjectBody,
-                    PEPROCESS Process,
-                    ULONG HandleCount,
-                    ACCESS_MASK GrantedAccess)
+                    ACCESS_MASK GrantedAccess,
+                    ULONG HandleCount)
 {
    PWINSTATION_OBJECT WinSta = (PWINSTATION_OBJECT)ObjectBody;
    NTSTATUS Status;
Index: subsystems/win32/win32k/include/winsta.h
===================================================================
--- subsystems/win32/win32k/include/winsta.h	(revision 21808)
+++ subsystems/win32/win32k/include/winsta.h	(working copy)
@@ -54,11 +54,11 @@
 
 NTSTATUS
 STDCALL
-IntWinStaObjectOpen(OB_OPEN_REASON Reason,
-                    PVOID ObjectBody,
-                    PEPROCESS Process,
-                    ULONG HandleCount,
-                    ACCESS_MASK GrantedAccess);
+IntWinStaObjectOpen(IN OB_OPEN_REASON Reason,
+                    IN PEPROCESS Process OPTIONAL,
+                    IN PVOID ObjectBody,
+                    IN ACCESS_MASK GrantedAccess,
+                    IN ULONG HandleCount);
 
 VOID STDCALL
 IntWinStaObjectDelete(PVOID DeletedObject);
Index: subsystems/win32/win32k/main/dllmain.c
===================================================================
--- subsystems/win32/win32k/main/dllmain.c	(revision 21808)
+++ subsystems/win32/win32k/main/dllmain.c	(working copy)
@@ -23,6 +23,7 @@
 
 #include <w32k.h>
 #include <include/napi.h>
+#include <win32k/callout.h>
 
 #define NDEBUG
 #include <debug.h>
@@ -164,7 +165,7 @@
 NTSTATUS 
 STDCALL
 Win32kThreadCallback(struct _ETHREAD *Thread,
-                     BOOLEAN Create)
+                     PSW32THREADCALLOUTTYPE Type)
 {
     struct _EPROCESS *Process;
     PW32THREAD Win32Thread;
@@ -193,7 +194,7 @@
         PsSetThreadWin32Thread(Thread, Win32Thread);
         /* FIXME - unlock the process */
     }
-  if (Create)
+  if (Type == PsW32ThreadCalloutInitialize)
     {
       HWINSTA hWinSta = NULL;
       HDESK hDesk = NULL;
@@ -380,7 +381,7 @@
     /*
      * Register Object Manager Callbacks
      */
-    CalloutData.WinStaCreate = IntWinStaObjectOpen;
+    CalloutData.WinStaOpen = IntWinStaObjectOpen;
     CalloutData.WinStaParse = IntWinStaObjectParse;
     CalloutData.WinStaDelete = IntWinStaObjectDelete;
     CalloutData.WinStaFind = IntWinStaObjectFind;
@@ -392,7 +393,7 @@
     /*
      * Register our per-process and per-thread structures.
      */
-    PsEstablishWin32Callouts(&CalloutData);
+    PsEstablishWin32Callouts((PWIN32_CALLOUTS_FPNS)&CalloutData);
 
     GlobalUserHeap = UserCreateHeap(&GlobalUserHeapSection,
                                     &GlobalUserHeapBase,
Index: subsystems/win32/win32k/objects/dc.c
===================================================================
--- subsystems/win32/win32k/objects/dc.c	(revision 21808)
+++ subsystems/win32/win32k/objects/dc.c	(working copy)
@@ -28,6 +28,14 @@
 #define NDEBUG
 #include <debug.h>
 
+/* ROS Internal. Please deprecate */
+NTHALAPI
+BOOLEAN
+NTAPI
+HalQueryDisplayOwnership(
+    VOID
+);
+
 #ifndef OBJ_COLORSPACE
 #define OBJ_COLORSPACE	(14)
 #endif
Index: subsystems/win32/win32k/w32k.h
===================================================================
--- subsystems/win32/win32k/w32k.h	(revision 21808)
+++ subsystems/win32/win32k/w32k.h	(working copy)
@@ -17,6 +17,7 @@
 #include <ntddk.h>
 #include <ntddmou.h>
 #include <ntndk.h>
+//#include <rtltypes.h>
 
 /* Win32 Headers */
 /* FIXME: Defines in winbase.h that we need... */
@@ -56,9 +57,6 @@
 #include <win32k/ntgdibad.h>
 #include <ntgdi.h>
 
-/* For access to SECTION_OBJECT. FIXME: Once compatible with NT, use NDK! */
-#include <internal/mm.h>
-
 /* Internal Win32K Header */
 #include "include/win32k.h"
 
Index: include/reactos/libs/epsapi/epsapi.h
===================================================================
--- include/reactos/libs/epsapi/epsapi.h	(revision 21808)
+++ include/reactos/libs/epsapi/epsapi.h	(working copy)
@@ -32,7 +32,7 @@
 typedef NTSTATUS (NTAPI *PTHREAD_ENUM_ROUTINE)(IN PSYSTEM_THREAD_INFORMATION CurrentThread,
                                                IN OUT PVOID CallbackContext);
 
-typedef NTSTATUS (NTAPI *PSYSMOD_ENUM_ROUTINE)(IN PSYSTEM_MODULE_INFORMATION_ENTRY CurrentModule,
+typedef NTSTATUS (NTAPI *PSYSMOD_ENUM_ROUTINE)(IN PRTL_PROCESS_MODULE_INFORMATION CurrentModule,
                                                IN OUT PVOID CallbackContext);
 
 typedef NTSTATUS (NTAPI *PPROCMOD_ENUM_ROUTINE)(IN HANDLE ProcessHandle,
@@ -100,18 +100,18 @@
 
 /* capturing & walking */
 NTSTATUS NTAPI
-PsaCaptureSystemModules(OUT PSYSTEM_MODULE_INFORMATION * SystemModules);
+PsaCaptureSystemModules(OUT PRTL_PROCESS_MODULES * SystemModules);
 
 NTSTATUS NTAPI
-PsaWalkSystemModules(IN PSYSTEM_MODULE_INFORMATION SystemModules,
+PsaWalkSystemModules(IN PRTL_PROCESS_MODULES SystemModules,
                      IN PSYSMOD_ENUM_ROUTINE Callback,
                      IN OUT PVOID CallbackContext);
 
-PSYSTEM_MODULE_INFORMATION_ENTRY FASTCALL
-PsaWalkFirstSystemModule(IN PSYSTEM_MODULE_INFORMATION SystemModules);
+PRTL_PROCESS_MODULE_INFORMATION FASTCALL
+PsaWalkFirstSystemModule(IN PRTL_PROCESS_MODULES SystemModules);
 
-PSYSTEM_MODULE_INFORMATION_ENTRY FASTCALL
-PsaWalkNextSystemModule(IN PSYSTEM_MODULE_INFORMATION CurrentSystemModule);
+PRTL_PROCESS_MODULE_INFORMATION FASTCALL
+PsaWalkNextSystemModule(IN PRTL_PROCESS_MODULES CurrentSystemModule);
 
 /* Process modules */
 NTSTATUS NTAPI
Index: include/reactos/arc/arc.h
===================================================================
--- include/reactos/arc/arc.h	(revision 21808)
+++ include/reactos/arc/arc.h	(working copy)
@@ -1,10 +1,6 @@
-/* ARC LOADER TYPES *********************************************************/
+#ifndef _ARC_
+#define _ARC_
 
-#ifndef __INCLUDE_ARC_H
-#define __INCLUDE_ARC_H
-
-/* Types */
-
 typedef enum _IDENTIFIER_FLAG
 {
     Failed = 0x01,
@@ -28,6 +24,20 @@
     MaximumClass
 } CONFIGURATION_CLASS;
 
+typedef enum
+{
+    HwFileDriver,
+    HwFilePort,
+    HwFileClass,
+    HwFileInf,
+    HwFileDll,
+    HwFileDetect,
+    HwFileHal,
+    HwFileCatalog,
+    HwFileMax,
+    HwFileDynUpdt = 31,
+} HwFileType;
+
 typedef struct _CONFIGURATION_COMPONENT
 {
     CONFIGURATION_CLASS Class;
@@ -47,7 +57,8 @@
     struct _CONFIGURATION_COMPONENT_DATA *Parent;
     struct _CONFIGURATION_COMPONENT_DATA *Child;
     struct _CONFIGURATION_COMPONENT_DATA *Sibling;
-    CONFIGURATION_COMPONENT Component;
+    CONFIGURATION_COMPONENT ComponentEntry;
+    PVOID ConfigurationData;
 } CONFIGURATION_COMPONENT_DATA, *PCONFIGURATION_COMPONENT_DATA;
 
 typedef struct _ARC_DISK_INFORMATION
@@ -55,4 +66,202 @@
     LIST_ENTRY DiskSignatureListHead;
 } ARC_DISK_INFORMATION, *PARC_DISK_INFORMATION;
 
+typedef struct _MONITOR_CONFIGURATION_DATA
+{
+    USHORT Version;
+    USHORT Revision;
+    USHORT HorizontalResolution;
+    USHORT HorizontalDisplayTime;
+    USHORT HorizontalBackPorch;
+    USHORT HorizontalFrontPorch;
+    USHORT HorizontalSync;
+    USHORT VerticalResolution;
+    USHORT VerticalBackPorch;
+    USHORT VerticalFrontPorch;
+    USHORT VerticalSync;
+    USHORT HorizontalScreenSize;
+    USHORT VerticalScreenSize;
+} MONITOR_CONFIGURATION_DATA, *PMONITOR_CONFIGURATION_DATA;
+
+typedef struct _FLOPPY_CONFIGURATION_DATA
+{
+    USHORT Version;
+    USHORT Revision;
+    CHAR Size[8];
+    ULONG MaxDensity;
+    ULONG MountDensity;
+} FLOPPY_CONFIGURATION_DATA, *PFLOPPY_CONFIGURATION_DATA;
+
+//
+// SMBIOS Table Header (FIXME: maybe move to smbios.h?)
+//
+typedef struct _SMBIOS_TABLE_HEADER
+{
+   CHAR Signature[4];
+   UCHAR Checksum;
+   UCHAR Length;
+   UCHAR MajorVersion;
+   UCHAR MinorVersion;
+   USHORT MaximumStructureSize;
+   UCHAR EntryPointRevision;
+   UCHAR Reserved[5];
+   CHAR Signature2[5];
+   UCHAR IntermediateChecksum;
+   USHORT StructureTableLength;
+   ULONG StructureTableAddress;
+   USHORT NumberStructures;
+   UCHAR Revision;
+} SMBIOS_TABLE_HEADER, *PSMBIOS_TABLE_HEADER;
+
+//
+// NLS Data Block
+//
+typedef struct _NLS_DATA_BLOCK
+{
+    PVOID AnsiCodePageData;
+    PVOID OemCodePageData;
+    PVOID UnicodeCodePageData;
+} NLS_DATA_BLOCK, *PNLS_DATA_BLOCK;
+
+//
+// Subsystem Specific Loader Blocks
+//
+typedef struct _PROFILE_PARAMETER_BLOCK
+{
+    USHORT Status;
+    USHORT Reserved;
+    USHORT DockingState;
+    USHORT Capabilities;
+    ULONG DockID;
+    ULONG SerialNumber;
+} PROFILE_PARAMETER_BLOCK, *PPROFILE_PARAMETER_BLOCK;
+
+typedef struct _HEADLESS_LOADER_BLOCK
+{
+    UCHAR UsedBiosSettings;
+    UCHAR DataBits;
+    UCHAR StopBits;
+    UCHAR Parity;
+    ULONG BaudRate;
+    ULONG PortNumber;
+    PUCHAR PortAddress;
+    USHORT PciDeviceId;
+    USHORT PciVendorId;
+    UCHAR PciBusNumber;
+    UCHAR PciSlotNumber;
+    UCHAR PciFunctionNumber;
+    ULONG PciFlags;
+    GUID SystemGUID;
+    UCHAR IsMMIODevice;
+    UCHAR TerminalType;
+} HEADLESS_LOADER_BLOCK, *PHEADLESS_LOADER_BLOCK;
+
+typedef struct _NETWORK_LOADER_BLOCK
+{
+    PCHAR DHCPServerACK;
+    ULONG DHCPServerACKLength;
+    PCHAR BootServerReplyPacket;
+    ULONG BootServerReplyPacketLength;
+} NETWORK_LOADER_BLOCK, *PNETWORK_LOADER_BLOCK;
+
+typedef struct _LOADER_PERFORMANCE_DATA
+{
+    ULONGLONG StartTime;
+    ULONGLONG EndTime;
+} LOADER_PERFORMANCE_DATA, *PLOADER_PERFORMANCE_DATA;
+
+//
+// Extended Loader Parameter Block
+//
+typedef struct _LOADER_PARAMETER_EXTENSION
+{
+    ULONG Size;
+    PROFILE_PARAMETER_BLOCK Profile;
+    ULONG MajorVersion;
+    ULONG MinorVersion;
+    PVOID EmInfFileImage;
+    ULONG EmInfFileSize;
+    PVOID TriageDumpBlock;
+    //
+    // NT 5.1
+    //
+    ULONG LoaderPagesSpanned;
+    PHEADLESS_LOADER_BLOCK HeadlessLoaderBlock;
+    PSMBIOS_TABLE_HEADER SMBiosEPSHeader;
+    PVOID DrvDBImage;
+    ULONG DrvDBSize;
+    PNETWORK_LOADER_BLOCK NetworkLoaderBlock;
+    //
+    // NT 5.2+
+    //
+    PCHAR HalpIRQLToTPR;
+    PCHAR HalpVectorToIRQL;
+    LIST_ENTRY FirmwareDescriptorListHead;
+    PVOID AcpiTable;
+    ULONG AcpiTableSize;
+    //
+    // NT 5.2 SP1+
+    //
+    ULONG BootViaWinload:1;
+    ULONG BootViaEFI:1;
+    ULONG Reserved:30;
+    LOADER_PERFORMANCE_DATA LoaderPerformanceData;
+    LIST_ENTRY BootApplicationPersistentData;
+    PVOID WmdTestResult;
+    GUID BootIdentifier;
+} LOADER_PARAMETER_EXTENSION, *PLOADER_PARAMETER_EXTENSION;
+
+//
+// Architecture specific Loader Parameter Blocks
+//
+typedef struct _IA64_LOADER_BLOCK
+{
+    ULONG PlaceHolder;
+} IA64_LOADER_BLOCK, *PIA64_LOADER_BLOCK;
+
+typedef struct _ALPHA_LOADER_BLOCK
+{
+    ULONG PlaceHolder;
+} ALPHA_LOADER_BLOCK, *PALPHA_LOADER_BLOCK;
+
+typedef struct _I386_LOADER_BLOCK
+{
+    PVOID CommonDataArea;
+    ULONG MachineType;
+    ULONG Reserved;
+} I386_LOADER_BLOCK, *PI386_LOADER_BLOCK;
+
+//
+// Loader Parameter Block
+//
+typedef struct _LOADER_PARAMETER_BLOCK
+{
+    LIST_ENTRY LoadOrderListHead;
+    LIST_ENTRY MemoryDescriptorListHead;
+    LIST_ENTRY BootDriverListHead;
+    ULONG_PTR KernelStack;
+    ULONG_PTR Prcb;
+    ULONG_PTR Process;
+    ULONG_PTR Thread;
+    ULONG RegistryLength;
+    PVOID RegistryBase;
+    PCONFIGURATION_COMPONENT_DATA ConfigurationRoot;
+    LPSTR ArcBootDeviceName;
+    LPSTR ArcHalDeviceName;
+    LPSTR NtBootPathName;
+    LPSTR NtHalPathName;
+    LPSTR LoadOptions;
+    PNLS_DATA_BLOCK NlsData;
+    PARC_DISK_INFORMATION ArcDiskInformation;
+    PVOID OemFontFile;
+    struct _SETUP_LOADER_BLOCK *SetupLdrBlock;
+    PLOADER_PARAMETER_EXTENSION Extension;
+    union
+    {
+        I386_LOADER_BLOCK I386;
+        ALPHA_LOADER_BLOCK Alpha;
+        IA64_LOADER_BLOCK Ia64;
+    } u;
+} LOADER_PARAMETER_BLOCK, *PLOADER_PARAMETER_BLOCK;
+
 #endif
Index: include/reactos/drivers/diskdump/diskdump.h
===================================================================
--- include/reactos/drivers/diskdump/diskdump.h	(revision 21808)
+++ include/reactos/drivers/diskdump/diskdump.h	(working copy)
@@ -2,7 +2,7 @@
 #define __DISKDUMP_H
 
 #include <ntddscsi.h>
-#include <ndk/ntndk.h>
+#include <ketypes.h>
 
 #define MM_CORE_DUMP_HEADER_MAGIC         (0xdeafbead)
 #define MM_CORE_DUMP_HEADER_VERSION       (0x1)
Index: include/winsock2.h
===================================================================
--- include/winsock2.h	(revision 21808)
+++ include/winsock2.h	(working copy)
@@ -214,7 +214,8 @@
 #define IMPLINK_IP	155
 #define IMPLINK_LOWEXPER	156
 #define IMPLINK_HIGHEXPER       158
-struct in_addr {
+#ifndef s_addr
+typedef struct in_addr {
 	union {
 		struct { u_char s_b1,s_b2,s_b3,s_b4; } S_un_b;
 		struct { u_short s_w1,s_w2; } S_un_w;
@@ -226,7 +227,8 @@
 #define s_imp   S_un.S_un_w.s_w2
 #define s_impno S_un.S_un_b.s_b4
 #define s_lh    S_un.S_un_b.s_b3
-};
+} IN_ADDR, *PIN_ADDR;
+#endif
 #define IN_CLASSA(i)	((long)(i)&0x80000000)
 #define IN_CLASSA_NET	0xff000000
 #define IN_CLASSA_NSHIFT	24
@@ -589,8 +591,6 @@
 typedef struct linger LINGER;
 typedef struct linger *PLINGER;
 typedef struct linger *LPLINGER;
-typedef struct in_addr IN_ADDR;
-typedef struct in_addr *PIN_ADDR;
 typedef struct in_addr *LPIN_ADDR;
 typedef struct fd_set FD_SET;
 typedef struct fd_set *PFD_SET;
Index: include/ws2tcpip.h
===================================================================
--- include/ws2tcpip.h	(revision 21808)
+++ include/ws2tcpip.h	(working copy)
@@ -144,13 +144,7 @@
    (sizeof(struct ip_msfilter) - sizeof(struct in_addr) \
    + (numsrc) * sizeof(struct in_addr))
 
-struct in_pktinfo {
-	IN_ADDR ipi_addr;
-	UINT    ipi_ifindex;
-};
-typedef struct in_pktinfo IN_PKTINFO;
 
-
 /* ipv6 */
 /* These require XP or .NET Server or use of add-on IPv6 stacks on NT 4
   or higher */
Index: include/winnt.h
===================================================================
--- include/winnt.h	(revision 21808)
+++ include/winnt.h	(working copy)
@@ -968,7 +968,9 @@
 #define SECTION_QUERY 1
 #define SECTION_MAP_EXECUTE 8
 #define SECTION_ALL_ACCESS 0xf001f
+#ifndef __NTDDK_H
 #define MESSAGE_RESOURCE_UNICODE 1
+#endif
 #define RTL_CRITSECT_TYPE 0
 #define RTL_RESOURCE_TYPE 1
 /* Also in winddk.h */
@@ -2500,7 +2502,6 @@
 	DWORD Protect;
 	DWORD Type;
 } MEMORY_BASIC_INFORMATION,*PMEMORY_BASIC_INFORMATION;
-#endif
 typedef struct _MESSAGE_RESOURCE_ENTRY {
 	WORD Length;
 	WORD Flags;
@@ -2515,6 +2516,7 @@
 	DWORD NumberOfBlocks;
 	MESSAGE_RESOURCE_BLOCK Blocks[1];
 } MESSAGE_RESOURCE_DATA,*PMESSAGE_RESOURCE_DATA;
+#endif
 typedef struct _LIST_ENTRY {
 	struct _LIST_ENTRY *Flink;
 	struct _LIST_ENTRY *Blink;
Index: include/ddk/winddk.h
===================================================================
--- include/ddk/winddk.h	(revision 21808)
+++ include/ddk/winddk.h	(working copy)
@@ -200,8 +200,12 @@
 #define NtCurrentProcess() ( (HANDLE)(LONG_PTR) -1 )  
 #define ZwCurrentProcess() NtCurrentProcess()         
 #define NtCurrentThread() ( (HANDLE)(LONG_PTR) -2 )   
-#define ZwCurrentThread() NtCurrentThread()      
+#define ZwCurrentThread() NtCurrentThread()     
+#ifdef _REACTOS_ 
+#define KIP0PCRADDRESS                      0xff000000
+#else
 #define KIP0PCRADDRESS                      0xffdff000
+#endif
 
 #define KERNEL_STACK_SIZE                   12288
 #define KERNEL_LARGE_STACK_SIZE             61440
@@ -231,6 +235,8 @@
 #define HIGH_PRIORITY                     31
 #define MAXIMUM_PRIORITY                  32
 
+#define MAXIMUM_SUSPEND_COUNT             MAXCHAR
+
 #define FILE_SUPERSEDED                   0x00000000
 #define FILE_OPENED                       0x00000001
 #define FILE_CREATED                      0x00000002
@@ -407,6 +413,8 @@
     LONG High2Time;
 } KSYSTEM_TIME, *PKSYSTEM_TIME;
 
+extern volatile KSYSTEM_TIME KeTickCount;
+
 typedef struct _KUSER_SHARED_DATA 
 {
     ULONG TickCountLowDeprecated;
@@ -1024,6 +1032,8 @@
 
 #define LOCK_QUEUE_WAIT                   1
 #define LOCK_QUEUE_OWNER                  2
+#define LOCK_QUEUE_TIMER_LOCK_SHIFT       4
+#define LOCK_QUEUE_TIMER_TABLE_LOCKS (1 << (8 - LOCK_QUEUE_TIMER_LOCK_SHIFT))
 
 typedef enum _KSPIN_LOCK_QUEUE_NUMBER {
   LockQueueDispatcherLock,
@@ -1041,7 +1051,10 @@
   LockQueueNtfsStructLock,
   LockQueueAfdWorkQueueLock,
   LockQueueBcbLock,
-  LockQueueMaximumLock
+  LockQueueMmNonPagedPoolLock,
+  LockQueueUnusedSpare16,
+  LockQueueTimerTableLock,
+  LockQueueMaximumLock = LockQueueTimerTableLock + LOCK_QUEUE_TIMER_TABLE_LOCKS
 } KSPIN_LOCK_QUEUE_NUMBER, *PKSPIN_LOCK_QUEUE_NUMBER;
 
 typedef struct _KSPIN_LOCK_QUEUE {
Index: include/ndk/haltypes.h
===================================================================
--- include/ndk/haltypes.h	(revision 21808)
+++ include/ndk/haltypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -27,28 +27,9 @@
 #ifndef NTOS_MODE_USER
 
 //
-// Multi-Boot Flags (REMOVE ME)
-//
-#ifdef _REACTOS_
-#define MB_FLAGS_MEM_INFO                   (0x1)
-#define MB_FLAGS_BOOT_DEVICE                (0x2)
-#define MB_FLAGS_COMMAND_LINE               (0x4)
-#define MB_FLAGS_MODULE_INFO                (0x8)
-#define MB_FLAGS_AOUT_SYMS                  (0x10)
-#define MB_FLAGS_ELF_SYMS                   (0x20)
-#define MB_FLAGS_MMAP_INFO                  (0x40)
-#define MB_FLAGS_DRIVES_INFO                (0x80)
-#define MB_FLAGS_CONFIG_TABLE               (0x100)
-#define MB_FLAGS_BOOT_LOADER_NAME           (0x200)
-#define MB_FLAGS_APM_TABLE                  (0x400)
-#define MB_FLAGS_GRAPHICS_TABLE             (0x800)
-#define MB_FLAGS_ACPI_TABLE                 (0x1000)
-#endif
-
-//
 // HalShutdownSystem Types
 //
-typedef enum _FIRMWARE_ENTRY
+typedef enum _FIRMWARE_REENTRY
 {
     HalHaltRoutine,
     HalPowerDownRoutine,
@@ -59,190 +40,112 @@
 } FIRMWARE_REENTRY, *PFIRMWARE_REENTRY;
 
 //
-// Hal Private dispatch Table
+// HAL Private function Types
 //
-#define HAL_PRIVATE_DISPATCH_VERSION        2
-typedef struct _HAL_PRIVATE_DISPATCH
-{
-    ULONG Version;
-    PVOID HalHandlerForBus;
-    PVOID HalHandlerForBus2;
-    PVOID HalLocateHiberRanges;
-    PVOID HalRegisterBusHandler;
-    PVOID HalSetWakeEnable;
-    PVOID HalSetWakeAlarm;
-    PVOID HalTranslateBusAddress;
-    PVOID HalTranslateBusAddress2;
-    PVOID HalHaltSystem;
-    PVOID Null;
-    PVOID Null2;
-    PVOID HalAllocateMapRegisters;
-    PVOID KdSetupPciDeviceForDebugging;
-    PVOID KdReleasePciDeviceforDebugging;
-    PVOID KdGetAcpiTablePhase0;
-    PVOID HalReferenceHandler;
-    PVOID HalVectorToIDTEntry;
-    PVOID MatchAll;
-    PVOID KdUnmapVirtualAddress;
-} HAL_PRIVATE_DISPATCH, *PHAL_PRIVATE_DISPATCH;
+typedef
+PBUS_HANDLER
+(*pHalHandlerForConfigSpace)(
+    IN BUS_DATA_TYPE  ConfigSpace,
+    IN ULONG BusNumber
+);
 
-#ifndef _REACTOS_
-//
-// NLS Data Block
-//
-typedef struct _NLS_TABLE_DATA
-{
-    PVOID AnsiCodePageData;
-    PVOID OemCodePageData;
-    PVOID UnicodeCodePageData;
-} NLS_TABLE_DATA, *PNLS_TABLE_DATA;
+typedef
+NTSTATUS
+(*PINSTALL_BUS_HANDLER)(
+    IN PBUS_HANDLER Bus
+);
 
-//
-// Subsystem Specific Loader Blocks
-//
-typedef struct _PROFILE_PARAMETER_BLOCK
-{
-    USHORT DockData0;
-    USHORT DockData1;
-    USHORT DockData2;
-    USHORT DockData3;
-    ULONG DockData4;
-    ULONG DockData5;
-} PROFILE_PARAMETER_BLOCK, *PPROFILE_PARAMETER_BLOCK;
+typedef
+NTSTATUS
+(*pHalRegisterBusHandler)(
+    IN INTERFACE_TYPE InterfaceType,
+    IN BUS_DATA_TYPE ConfigSpace,
+    IN ULONG BusNumber,
+    IN INTERFACE_TYPE ParentInterfaceType,
+    IN ULONG ParentBusNumber,
+    IN ULONG ContextSize,
+    IN PINSTALL_BUS_HANDLER InstallCallback,
+    OUT PBUS_HANDLER *BusHandler
+);
 
-typedef struct _HEADLESS_LOADER_BLOCK
-{
-    UCHAR Unknown[0xC];
-} HEADLESS_LOADER_BLOCK, *PHEADLESS_LOADER_BLOCK;
+typedef
+VOID
+(*pHalSetWakeEnable)(
+    IN BOOLEAN Enable
+);
 
-typedef struct _NETWORK_LOADER_BLOCK
-{
-    UCHAR Unknown[0xC];
-} NETWORK_LOADER_BLOCK, *PNETWORK_LOADER_BLOCK;
 
-//
-// Extended Loader Parameter Block
-//
-typedef struct _LOADER_PARAMETER_EXTENSION
-{
-    ULONG Size;
-    PROFILE_PARAMETER_BLOCK ProfileParameterBlock;
-    ULONG MajorVersion;
-    ULONG MinorVersion;
-    PVOID SpecialConfigInfFile;
-    ULONG SpecialConfigInfSize;
-    PVOID TriageDumpData;
-    //
-    // NT 5.1
-    //
-    ULONG NumberOfPages;
-    PHEADLESS_LOADER_BLOCK HeadlessLoaderBlock;
-    PVOID Unknown1;
-    PVOID PrefetchDatabaseBase;
-    ULONG PrefetchDatabaseSize;
-    PNETWORK_LOADER_BLOCK NetworkLoaderBlock;
-    //
-    // NT 5.2+
-    //
-    PVOID Reserved[2];
-    LIST_ENTRY FirmwareListEntry;
-    PVOID AcpiTableBase;
-    ULONG AcpiTableSize;
-} LOADER_PARAMETER_EXTENSION, *PLOADER_PARAMETER_EXTENSION;
+typedef
+VOID
+(*pHalSetWakeAlarm)(
+    IN ULONGLONG AlartTime,
+    IN PTIME_FIELDS TimeFields
+);
 
-//
-// Architecture specific Loader Parameter Blocks
-//
-typedef struct _I386_LOADER_BLOCK
-{
-    PVOID CommonDataArea;
-    ULONG MachineType;
-    ULONG Reserved;
-} I386_LOADER_BLOCK, *PI386_LOADER_BLOCK;
+typedef
+VOID
+(*pHalLocateHiberRanges)(
+    IN PVOID MemoryMap
+);
 
-//
-// Setup Loader Parameter Block
-//
-typedef struct _SETUP_LOADER_BLOCK
-{
-    ULONG Unknown[139];
-    ULONG Flags;
-} SETUP_LOADER_BLOCK, *PSETUP_LOADER_BLOCK;
+typedef
+BOOLEAN
+(*pHalAllocateMapRegisters)(
+    IN PADAPTER_OBJECT AdapterObject,
+    IN ULONG Unknown,
+    IN ULONG Unknown2,
+    PMAP_REGISTER_ENTRY Registers
+);
 
 //
-// Loader Parameter Block
+// Hal Private dispatch Table
 //
-typedef struct _LOADER_PARAMETER_BLOCK
+#define HAL_PRIVATE_DISPATCH_VERSION        2
+typedef struct _HAL_PRIVATE_DISPATCH
 {
-    LIST_ENTRY LoadOrderListHead;
-    LIST_ENTRY MemoryDescriptorListHead;
-    LIST_ENTRY DriverList;
-    PVOID KernelStack;
-    PVOID Prcb;
-    PVOID Process;
-    PVOID Thread;
-    ULONG RegistryLength;
-    PVOID RegistryBase;
-    PCONFIGURATION_COMPONENT_DATA ConfigurationRoot;
-    LPSTR ArcBootDeviceName;
-    LPSTR ArcHalDeviceName;
-    LPSTR SystemRoot;
-    LPSTR BootRoot;
-    LPSTR CommandLine;
-    PNLS_TABLE_DATA NlsTables;
-    PARC_DISK_INFORMATION ArcDevices;
-    PVOID OEMFont;
-    PSETUP_LOADER_BLOCK SetupLdrBlock;
-    PLOADER_PARAMETER_EXTENSION LpbExtension;
-    union
-    {
-        I386_LOADER_BLOCK I386;
-    } u;
-} LOADER_PARAMETER_BLOCK, *PLOADER_PARAMETER_BLOCK;
+    ULONG Version;
+    pHalHandlerForBus HalHandlerForBus;
+    pHalHandlerForConfigSpace HalHandlerForConfigSpace;
+    pHalLocateHiberRanges HalLocateHiberRanges;
+    pHalRegisterBusHandler HalRegisterBusHandler;
+    pHalSetWakeEnable HalSetWakeEnable;
+    pHalSetWakeAlarm HalSetWakeAlarm;
+    pHalTranslateBusAddress HalPciTranslateBusAddress;
+    pHalAssignSlotResources HalPciAssignSlotResources;
+    pHalHaltSystem HalHaltSystem;
+    pHalFindBusAddressTranslation HalFindBusAddressTranslation;
+    pHalResetDisplay HalResetDisplay;
+    pHalAllocateMapRegisters HalAllocateMapRegisters;
+    pKdSetupPciDeviceForDebugging KdSetupPciDeviceForDebugging;
+    pKdReleasePciDeviceForDebugging KdReleasePciDeviceforDebugging;
+    pKdGetAcpiTablePhase0 KdGetAcpiTablePhase0;
+    pKdCheckPowerButton KdCheckPowerButton;
+    pHalVectorToIDTEntry HalVectorToIDTEntry;
+    pKdMapPhysicalMemory64 KdMapPhysicalMemory64;
+    pKdUnmapVirtualAddress KdUnmapVirtualAddress;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    pKdGetPciDataByOffset KdGetPciDataByOffset;
+    pKdSetPciDataByOffset KdSetPciDataByOffset;
+    PVOID HalGetInterruptVectorOverride;
+    PVOID HalGetVectorInputOverride;
+#endif
+} HAL_PRIVATE_DISPATCH, *PHAL_PRIVATE_DISPATCH;
 
-#else
-
 //
-// FIXME: ReactOS ONLY
+// Kernel Exports
 //
-typedef struct _LOADER_MODULE
-{
-    ULONG ModStart;
-    ULONG ModEnd;
-    ULONG String;
-    ULONG Reserved;
-} LOADER_MODULE, *PLOADER_MODULE;
-typedef struct _LOADER_PARAMETER_BLOCK
-{
-    ULONG Flags;
-    ULONG MemLower;
-    ULONG MemHigher;
-    ULONG BootDevice;
-    ULONG CommandLine;
-    ULONG ModsCount;
-    ULONG ModsAddr;
-    UCHAR Syms[12];
-    ULONG MmapLength;
-    ULONG MmapAddr;
-    ULONG DrivesCount;
-    ULONG DrivesAddr;
-    ULONG ConfigTable;
-    ULONG BootLoaderName;
-    ULONG PageDirectoryStart;
-    ULONG PageDirectoryEnd;
-    ULONG KernelBase;
-} LOADER_PARAMETER_BLOCK, *PLOADER_PARAMETER_BLOCK;
+#ifndef _NTOSKRNL_
+extern PHAL_PRIVATE_DISPATCH HalPrivateDispatchTable;
+#else
+extern HAL_PRIVATE_DISPATCH HalPrivateDispatchTable;
 #endif
 
 //
-// Kernel Exports
+// HAL Exports
 //
-#ifdef __NTOSKRNL__
-extern HAL_PRIVATE_DISPATCH HalPrivateDispatchTable;
-#else
-extern PHAL_PRIVATE_DISPATCH HalPrivateDispatchTable;
+#ifndef _NTHAL_
+extern PUCHAR *KdComPortInUse;
 #endif
-extern ULONG KdComPortInUse;
 
 #endif
 #endif
Index: include/ndk/ifssupp.h
===================================================================
--- include/ndk/ifssupp.h	(revision 21808)
+++ include/ndk/ifssupp.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 #ifndef _NTIFS_
Index: include/ndk/iotypes.h
===================================================================
--- include/ndk/iotypes.h	(revision 21808)
+++ include/ndk/iotypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -167,6 +167,14 @@
 #define DNUF_NOT_DISABLEABLE                    0x0008
 
 //
+// Undocumented WMI Registration Flags
+//
+#define WMIREG_FLAG_TRACE_PROVIDER          0x00010000
+#define WMIREG_FLAG_TRACE_NOTIFY_MASK       0x00F00000
+#define WMIREG_NOTIFY_DISK_IO               0x00100000
+#define WMIREG_NOTIFY_TDI_IO                0x00200000
+
+//
 // I/O Completion Information Class for NtQueryIoCompletionInformation
 //
 typedef enum _IO_COMPLETION_INFORMATION_CLASS
@@ -201,6 +209,24 @@
     MaximumInterfaceType
 }INTERFACE_TYPE, *PINTERFACE_TYPE;
 
+typedef enum _BUS_DATA_TYPE
+{
+    ConfigurationSpaceUndefined = -1,
+    Cmos,
+    EisaConfiguration,
+    Pos,
+    CbusConfiguration,
+    PCIConfiguration,
+    VMEConfiguration,
+    NuBusConfiguration,
+    PCMCIAConfiguration,
+    MPIConfiguration,
+    MPSAConfiguration,
+    PNPISAConfiguration,
+    SgiInternalConfiguration,
+    MaximumBusDataType
+} BUS_DATA_TYPE, *PBUS_DATA_TYPE;
+
 //
 // File Information Classes for NtQueryInformationFile
 //
@@ -491,6 +517,21 @@
     LARGE_INTEGER ValidDataLength;
 } FILE_VALID_DATA_LENGTH_INFORMATION, *PFILE_VALID_DATA_LENGTH_INFORMATION;
 
+typedef struct _FILE_DIRECTORY_INFORMATION
+{
+    ULONG NextEntryOffset;
+    ULONG FileIndex;
+    LARGE_INTEGER CreationTime;
+    LARGE_INTEGER LastAccessTime;
+    LARGE_INTEGER LastWriteTime;
+    LARGE_INTEGER ChangeTime;
+    LARGE_INTEGER EndOfFile;
+    LARGE_INTEGER AllocationSize;
+    ULONG FileAttributes;
+    ULONG FileNameLength;
+    WCHAR FileName[1];
+} FILE_DIRECTORY_INFORMATION, *PFILE_DIRECTORY_INFORMATION;
+
 //
 // File System Information structures for NtQueryInformationFile
 //
@@ -997,6 +1038,30 @@
 #endif
 
 //
+// Firmware Boot File Path
+//
+typedef struct _FILE_PATH
+{
+    ULONG Version;
+    ULONG Length;
+    ULONG Type;
+    CHAR FilePath[1];
+} FILE_PATH, *PFILE_PATH;
+
+//
+// Firmware Boot Options
+//
+typedef struct _BOOT_OPTIONS
+{
+    ULONG Version;
+    ULONG Length;
+    ULONG Timeout;
+    ULONG CurrentBootEntryId;
+    ULONG NextBootEntryId;
+    WCHAR HeadlessRedirection[1];
+} BOOT_OPTIONS, *PBOOT_OPTIONS;
+
+//
 // APC Callback for NtCreateFile
 //
 typedef VOID
Index: include/ndk/dbgktypes.h
===================================================================
--- include/ndk/dbgktypes.h	(revision 21808)
+++ include/ndk/dbgktypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
Index: include/ndk/setypes.h
===================================================================
--- include/ndk/setypes.h	(revision 21808)
+++ include/ndk/setypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
